<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version
 * @author Guillermo N. Lorenzini
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

/**
 * Projects upload directories creator
 */
require_once("system/Cronjob.php");
require_once('StringUtils.php');
require_once('lib/external/propel/Propel.php');
require_once('lib/GFConf.php');
require_once('lib/core/ProjectPeer.php');


class CreateProjectsDirectories extends Cronjob {

	public function __construct() {
		$this->jobname = basename(__FILE__);
		parent::__construct();
	}
	
	public function run() {
		$isUploadEnabled = GFConf::get('system.ftp_upload');
		$path = GFConf::get('system.ftp_upload_dir');
		$apache_user = GFConf::get('system.apacheUser');
		$apache_group = GFConf::get('system.apacheGroup');

		if ($isUploadEnabled) {
			if (file_exists($path)) {
				$crit = new Criteria();
				$crit->add(ProjectPeer::STATUS, Project::STATUS_ACTIVE);
				$projects = ProjectPeer::doSelect($crit);
				foreach ($projects as $project) {
					$prName = $project->getUnixName();
					if (!file_exists($path.$prName)) {
						if (mkdir($path.$prName)) {
							echo $path.$prName." created.\n";
						} else{
							echo $path.$prName." couldn't be created.\n";
						}
					}else{
						echo $path.$prName." couldn't be created. Already exists.\n";
					}
				}
				system("chown -R {$apache_user}:{$apache_group} {$path}", $ret);
			} else {
				echo "FTP upload directory doesn't exist.\n";
			}
		}
		$this->commitLog();
	}
}

$cronjob = new CreateProjectsDirectories();
$cronjob->run();
?>
