CREATE TABLE docman_file (
    docman_file_id SERIAL PRIMARY KEY,
    docman_folder_id integer NOT NULL CONSTRAINT docmanfolderid_fk
      REFERENCES docman_folder(docman_folder_id) ON DELETE CASCADE,
    description text,
    is_locked boolean default true
);
CREATE INDEX docmanfile_docmanfolderid ON docman_file(docman_folder_id);

CREATE TABLE docman_file_version (
    docman_file_version_id SERIAL PRIMARY KEY,
    docman_file_id integer NOT NULL CONSTRAINT docmanfileid_fk
      REFERENCES docman_file(docman_file_id) ON DELETE CASCADE,
    create_date timestamptz not null default now(),
    changes text,
    version_number float,
    created_by integer not null CONSTRAINT userid_fk REFERENCES "user"(user_id) ON DELETE CASCADE
);
CREATE INDEX docmanfileversion_docmanfileid ON docman_file_version(docman_file_version_id);

INSERT INTO docman_file (docman_file_id,docman_folder_id,description,is_locked)
	SELECT filesystem_id,ref_id,' v1 ',false FROM filesystem WHERE section='docmanfolder';

SELECT setval('docman_file_docman_file_id_seq',(select max(docman_file_id) FROM docman_file));

INSERT INTO docman_file_version (docman_file_id,create_date,changes,version_number,created_by)
	SELECT filesystem_id,now(),' v1 ','1',posted_by FROM filesystem WHERE section='docmanfolder';

update filesystem set ref_id=(select docman_file_version_id FROM docman_file_version 
	WHERE docman_file_id=filesystem.filesystem_id) WHERE section='docmanfolder';

update filesystem set section='docmanfileversion' where section='docmanfolder';

--mv /var/lib/gforge/filesystem/docmanfolder/ /var/lib/gforge/filesystem/docmanfileversion
