
CREATE OR REPLACE FUNCTION del_serial_seq() RETURNS TRIGGER AS '
DECLARE
	seqname text;
BEGIN
	IF OLD.field_type=11 THEN
		seqname := ''tef_'' || OLD.tracker_extra_field_id || ''_seq'';
		-- The sequence may have been removed from the TrackerExtraField:deleteSequence() method. 
		-- This trigger is only useful when a "DELETE FROM tracker" is executed.
		IF EXISTS ( SELECT 1 FROM pg_class WHERE relname = seqname )  THEN
			EXECUTE ''DROP SEQUENCE '' || seqname;
		END IF;
	END IF;
	RETURN NULL;
END;'
LANGUAGE 'plpgsql';

CREATE TRIGGER del_serial_seq AFTER DELETE ON tracker_extra_field FOR EACH ROW EXECUTE PROCEDURE del_serial_seq();

CREATE OR REPLACE FUNCTION add_serial_seq() RETURNS TRIGGER AS '
BEGIN
	IF NEW.field_type= 11 THEN
		EXECUTE ''CREATE SEQUENCE '' || ''trackerfield_id'' || NEW.tracker_extra_field_id || ''_seq'';
	END IF;
	RETURN NULL;
END;'
LANGUAGE 'plpgsql';

CREATE TRIGGER add_serial_seq AFTER INSERT ON tracker_extra_field FOR EACH ROW EXECUTE PROCEDURE add_serial_seq();

