
DROP TRIGGER del_serial_seq ON tracker_extra_field;

CREATE OR REPLACE FUNCTION del_serial_seq() RETURNS TRIGGER AS '
DECLARE
	seqname text;
BEGIN
	IF OLD.field_type=11 THEN
		seqname := ''tef_'' || OLD.tracker_extra_field_id || ''_seq'';
		IF EXISTS ( SELECT 1 FROM pg_class WHERE relname = seqname )  THEN
			EXECUTE ''DROP SEQUENCE '' || seqname;
		END IF;
	END IF;
	RETURN NULL;
END;'
LANGUAGE 'plpgsql';

CREATE TRIGGER del_serial_seq AFTER DELETE ON tracker_extra_field FOR EACH ROW EXECUTE PROCEDURE del_serial_seq();

