<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'my_report_field_display' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class MyReportFieldDisplayMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.MyReportFieldDisplayMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("my_report_field_display");
		$tMap->setPhpName("MyReportFieldDisplay");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("my_report_field_display_my_report_field_display_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("MY_REPORT_FIELD_DISPLAY_ID", "MyReportFieldDisplayId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("MY_REPORT_ID", "MyReportId", "int", CreoleTypes::INTEGER, "my_report" , "MY_REPORT_ID", true);
		$tMap->addColumn("FIELD_NAME", "FieldName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("TYPE", "Type", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("ORDER_PRIORITY", "OrderPriority", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("ORDER_ASC", "OrderAsc", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("COLUMN_ORDER", "ColumnOrder", "int", CreoleTypes::INTEGER, true, null);
				
    }
}
