<?php
require_once 'propel/util/BasePeer.php';

// The object class -- needed for instanceof checks in this class.
// actual class may be a subclass -- as returned by UserPeer::getOMClass()
include_once 'core/User.php';
	
include_once 'core/CountryCode.php';
include_once 'core/CountryCodePeer.php';
	
include_once 'core/Language.php';
include_once 'core/LanguagePeer.php';
	
include_once 'core/Theme.php';
include_once 'core/ThemePeer.php';

/**
 * Base static class for performing query and update operations on the 'user' table.
 *
 *  
 *
 * @package core 
 */
abstract class BaseUserPeer
{

	/** the default database name for this class */
	const DATABASE_NAME = "gf5";

	/** the table name for this class */
	const TABLE_NAME = '"user"';

 
	/** the column name for the USER_ID field */
	const USER_ID = '"user".USER_ID';
 
	/** the column name for the UNIX_NAME field */
	const UNIX_NAME = '"user".UNIX_NAME';
 
	/** the column name for the EMAIL field */
	const EMAIL = '"user".EMAIL';
 
	/** the column name for the STATUS field */
	const STATUS = '"user".STATUS';
 
	/** the column name for the PASSWORD_MD5 field */
	const PASSWORD_MD5 = '"user".PASSWORD_MD5';
 
	/** the column name for the PASSWORD_CRYPT field */
	const PASSWORD_CRYPT = '"user".PASSWORD_CRYPT';
 
	/** the column name for the CREATE_DATE field */
	const CREATE_DATE = '"user".CREATE_DATE';
 
	/** the column name for the CONFIRM_HASH field */
	const CONFIRM_HASH = '"user".CONFIRM_HASH';
 
	/** the column name for the EMAIL_NEW field */
	const EMAIL_NEW = '"user".EMAIL_NEW';
 
	/** the column name for the TIMEZONE field */
	const TIMEZONE = '"user".TIMEZONE';
 
	/** the column name for the DATE_FORMAT field */
	const DATE_FORMAT = '"user".DATE_FORMAT';
 
	/** the column name for the ADDRESS field */
	const ADDRESS = '"user".ADDRESS';
 
	/** the column name for the ADDRESS2 field */
	const ADDRESS2 = '"user".ADDRESS2';
 
	/** the column name for the PHONE field */
	const PHONE = '"user".PHONE';
 
	/** the column name for the FAX field */
	const FAX = '"user".FAX';
 
	/** the column name for the TITLE field */
	const TITLE = '"user".TITLE';
 
	/** the column name for the FIRSTNAME field */
	const FIRSTNAME = '"user".FIRSTNAME';
 
	/** the column name for the LASTNAME field */
	const LASTNAME = '"user".LASTNAME';
 
	/** the column name for the CCODE field */
	const CCODE = '"user".CCODE';
 
	/** the column name for the LANGUAGE_ID field */
	const LANGUAGE_ID = '"user".LANGUAGE_ID';
 
	/** the column name for the THEME_ID field */
	const THEME_ID = '"user".THEME_ID';
 
	/** the column name for the EXTERNAL_ID field */
	const EXTERNAL_ID = '"user".EXTERNAL_ID';
 
	/** the column name for the LAST_LOGIN field */
	const LAST_LOGIN = '"user".LAST_LOGIN';
 
	/** the column name for the USER_TEXT1 field */
	const USER_TEXT1 = '"user".USER_TEXT1';
 
	/** the column name for the USER_TEXT2 field */
	const USER_TEXT2 = '"user".USER_TEXT2';
 
	/** the column name for the USER_TEXT3 field */
	const USER_TEXT3 = '"user".USER_TEXT3';
 
	/** the column name for the USER_TEXT4 field */
	const USER_TEXT4 = '"user".USER_TEXT4';
 
	/** the column name for the USER_TEXT5 field */
	const USER_TEXT5 = '"user".USER_TEXT5';
 
	/** the column name for the USER_TEXT6 field */
	const USER_TEXT6 = '"user".USER_TEXT6';
 
	/** the column name for the IS_GROUP field */
	const IS_GROUP = '"user".IS_GROUP';
 
	/** the column name for the PASSWORD_CHANGE_DATE field */
	const PASSWORD_CHANGE_DATE = '"user".PASSWORD_CHANGE_DATE';

	const IS_RESTRICTED = '"user".IS_RESTRICTED';
	

	/** number of columns for this peer */
	public static $numColumns = 32;
	
	/** number of lazy load columns for this peer */
	public static $numLazyLoadColumns = 0;
	
	/** A class that can be returned by this peer. */
	const CLASS_DEFAULT = "core.User";

	/** The PHP to DB Name Mapping */
	private static $phpNameMap = null;

	/**
	 * @return MapBuilder the map builder for this peer
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getMapBuilder()		
	{
		include_once 'core/map/UserMapBuilder.php';
		return BasePeer::getMapBuilder(UserMapBuilder::CLASS_NAME);
	}

	/**
	 * Gets a map (hash) of PHP names to DB column names.
	 *
	 * @return array The PHP to DB name map for this peer
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @todo Consider having template build the array rather than doing it at runtime.
	 */
	public static function getPhpNameMap()
	{
		if (self::$phpNameMap === null) {
			$map = UserPeer::getTableMap();
			$columns = $map->getColumns();
			$nameMap = array();
			foreach ($columns as $column) {
				$nameMap[$column->getPhpName()] = $column->getColumnName();
			}
			self::$phpNameMap = $nameMap;
		}
		return self::$phpNameMap;
	}
	
	/**
	 * Convenience method which changes table.column to alias.column.
	 *
	 * Using this method you can maintain SQL abstraction while using column aliases.
	 * <code>
	 *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
	 *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
	 * </code>
	 * @param string $alias The alias for the current table.
	 * @param string $column The column name for current table. (i.e. UserPeer::COLUMN_NAME).
	 * @return string
	 */
	public static function alias($alias, $column)
	{
		return $alias . substr($column, strlen(self::TABLE_NAME));
	}
	
	/**
	 * Add all the columns needed to create a new object.
	 * 
	 * Note: any columns that were marked with lazyLoad="true" in the
	 * XML schema will not be added to the select list and only loaded
	 * on demand.
	 *
	 * @param criteria object containing the columns to add.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function addSelectColumns(Criteria $criteria)
	{
		$criteria->addSelectColumn(self::USER_ID);
		$criteria->addSelectColumn(self::UNIX_NAME);
		$criteria->addSelectColumn(self::EMAIL);
		$criteria->addSelectColumn(self::STATUS);
		$criteria->addSelectColumn(self::PASSWORD_MD5);
		$criteria->addSelectColumn(self::PASSWORD_CRYPT);
		$criteria->addSelectColumn(self::CREATE_DATE);
		$criteria->addSelectColumn(self::CONFIRM_HASH);
		$criteria->addSelectColumn(self::EMAIL_NEW);
		$criteria->addSelectColumn(self::TIMEZONE);
		$criteria->addSelectColumn(self::DATE_FORMAT);
		$criteria->addSelectColumn(self::ADDRESS);
		$criteria->addSelectColumn(self::ADDRESS2);
		$criteria->addSelectColumn(self::PHONE);
		$criteria->addSelectColumn(self::FAX);
		$criteria->addSelectColumn(self::TITLE);
		$criteria->addSelectColumn(self::FIRSTNAME);
		$criteria->addSelectColumn(self::LASTNAME);
		$criteria->addSelectColumn(self::CCODE);
		$criteria->addSelectColumn(self::LANGUAGE_ID);
		$criteria->addSelectColumn(self::THEME_ID);
		$criteria->addSelectColumn(self::EXTERNAL_ID);
		$criteria->addSelectColumn(self::LAST_LOGIN);
		$criteria->addSelectColumn(self::USER_TEXT1);
		$criteria->addSelectColumn(self::USER_TEXT2);
		$criteria->addSelectColumn(self::USER_TEXT3);
		$criteria->addSelectColumn(self::USER_TEXT4);
		$criteria->addSelectColumn(self::USER_TEXT5);
		$criteria->addSelectColumn(self::USER_TEXT6);
		$criteria->addSelectColumn(self::IS_GROUP);
		$criteria->addSelectColumn(self::PASSWORD_CHANGE_DATE);
		$criteria->addSelectColumn(self::IS_RESTRICTED);
	}
	
	const COUNT = 'COUNT("user".USER_ID)';
	const COUNT_DISTINCT = 'COUNT(DISTINCT "user".USER_ID)';
  
	/**
	 * Returns the number of rows matching criteria.
	 *
	 * @param Criteria $criteria
	 * @param boolean $distinct Whether to select only distinct columns.
	 * @param Connection $con
	 * @return int Number of matching rows.
	 */
	public static function doCount(Criteria $criteria, $distinct = false, $con = null)
	{   
		// we're going to modify criteria, so copy it first
		$criteria = clone $criteria;
		
		// clear out anything that might confuse the ORDER BY clause
		$criteria->clearSelectColumns()->clearOrderByColumns();
		if ($distinct || in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->addSelectColumn(UserPeer::COUNT_DISTINCT);
		} else {
			$criteria->addSelectColumn(UserPeer::COUNT);	
		}
		
		$rs = UserPeer::doSelectRS($criteria, $con);		
		if ($rs->next()) {
			return $rs->getInt(1);
		} else {
			// no rows returned; we infer that means 0 matches.
			return 0;
		}
	}
  
	/**
	 * Method to select one object from the DB.
	 *
	 * @param Criteria $criteria object used to create the SELECT statement.
	 * @param Connection $con
	 * @return User	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectOne(Criteria $criteria, $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = UserPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}

	/**
	 * Method to do selects.
	 *
	 * @param Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param Connection $con
	 * @return array Array of selected Objects
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelect(Criteria $criteria, $con = null)
	{
		return UserPeer::populateObjects(UserPeer::doSelectRS($criteria, $con));
	}
	
	/**
	 * Prepares the Criteria object and uses the parent doSelect()
	 * method to get a ResultSet.
	 * 
	 * Use this method directly if you want to just get the resultset
	 * (instead of an array of objects).
	 *
	 * @param Criteria $criteria The Criteria object used to build the SELECT statement.
	 * @param Connection $con the connection to use
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 * @return ResultSet The resultset object with numerically-indexed fields.
	 * @see BasePeer::doSelect()
	 */
	public static function doSelectRS(Criteria $criteria, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}				

		if (!$criteria->getSelectColumns()) {
			UserPeer::addSelectColumns($criteria);
		}
	
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		// BasePeer returns a Creole ResultSet, set to return
		// rows indexed numerically.		   
		return BasePeer::doSelect($criteria, $con);
	}

	/**
	 * The returned array will contain objects of the default type or
	 * objects that inherit from the default.
	 *
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function populateObjects(ResultSet $rs)
	{
		$results = array();
		
		// set the class once to avoid overhead in the loop
		$cls = UserPeer::getOMClass();
		$cls = Propel::import($cls);

		// populate the object(s)
		while($rs->next()) {
			
			$obj = new $cls();
			$obj->hydrate($rs);
			$results[] = $obj;
		}
		return $results;
	}



	/**
	 * The class that the Peer will make instances of.
	 * If the BO is abstract then you must implement this method
	 * in the BO.
	 *
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function getOMClass()
	{ 
		return self::CLASS_DEFAULT;
		 
	}
 

	/**
	 * Method perform an INSERT on the database, given a User or Criteria object.
	 *
	 * @param mixed $values Criteria or User object containing data that is used to create the INSERT statement.
	 * @param Connection $con the connection to use
	 * @return mixed The new primary key.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doInsert($values, $con = null)
	{		
		if ($con === null)
			$con = Propel::getConnection(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = $values;
		} else {
			$criteria = $values->buildCriteria();
		}
		
		
		$criteria->remove(self::USER_ID); // remove pkey col since this table uses auto-increment
		 
		
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		try {
			// use transaction because $criteria could contain info
			// for more than one table (I guess, conceivably)
			$con->begin();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollback();
			throw $e;
		}
		
		return $pk;		
	}

	/**
	 * Method perform an UPDATE on the database, given a User or Criteria object.
	 *
	 * @param mixed $values Criteria or User object containing data that is used to create the UPDATE statement.
	 * @param Connection $con The connection to use (specify Connection object to exert more control over transactions).
	 * @return int The number of affected rows (if supported by underlying database driver).
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doUpdate($values, $con = null)
	{			
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$selectCriteria = new Criteria(self::DATABASE_NAME);
				
		if ($values instanceof Criteria) {
			$criteria = $values;
			$selectCriteria->put(self::USER_ID, $criteria->remove(self::USER_ID));
 
		} else { // $values is User object
			$criteria = $values->buildCriteria(); // gets full criteria
			$selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)			
		}	
		
		// set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		return BasePeer::doUpdate($selectCriteria, $criteria, $con);		
	}   
	
	/**
	 * Method to DELETE all rows from the user table.
	 *
	 * @return int The number of affected rows (if supported by underlying database driver).
	 */
	public static function doDeleteAll($con = null) 
	{
		if ($con === null) $con = Propel::getConnection(self::DATABASE_NAME);
		$affectedRows = 0; // initialize var to track total num of affected rows		
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			 
			$affectedRows += BasePeer::doDeleteAll(self::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	
	/**
	 * Method perform a DELETE on the database, given a User or Criteria object OR a primary key value.
	 *
	 * @param mixed $values Criteria or User object or primary key which is used to create the DELETE statement 
	 * @param Connection $con the connection to use
	 * @return int 	The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
	 *				if supported by native driver or if emulated using Propel.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	 public static function doDelete($values, $con = null)
	 {		
		if ($con === null)
			$con = Propel::getConnection(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = $values;
		} elseif ($values instanceof User) {
			$criteria = $values->buildPkeyCriteria();
		} else {
			// it must be the primary key
			$criteria = new Criteria(self::DATABASE_NAME);
			$criteria->add(self::USER_ID, $values);
		}
			 
		// Set the correct dbName
		$criteria->setDbName(self::DATABASE_NAME);
		
		$affectedRows = 0; // initialize var to track total num of affected rows		
		
		try {
			// use transaction because $criteria could contain info
			// for more than one table or we could emulating ON DELETE CASCADE, etc.
			$con->begin();
			 
			$affectedRows += BasePeer::doDelete($criteria, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}		
	}	

	
	/**
	 * Validates all modified columns of given User object.
	 * If parameter $columns is either a single column name or an array of column names
	 * than only those columns are validated.
	 *
	 * NOTICE: This does not apply to primary or foreign keys for now.
	 *
	 * @param User $obj The object to validate.
	 * @param mixed $cols Column name or array of column names.
	 *
	 * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
	 */
	public static function doValidate(User $obj, $cols = null)
	{
		$columns = array();

		if ($cols)
		{
		  $dbMap = Propel::getDatabaseMap(self::DATABASE_NAME);
		  $tableMap = $dbMap->getTable(self::TABLE_NAME);

		  if (! is_array($cols)) {
			$cols = array($cols);
		  }

		  foreach($cols as $colName)
		  {
			if ($tableMap->containsColumn($colName))
			{
			  $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
			  $columns[$colName] = $obj->$get();
			}
		  }
		}
		else
		{
		}

		return BasePeer::doValidate(self::DATABASE_NAME, self::TABLE_NAME, $columns);
	}
	  


	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 *
	 * @param mixed $pk the primary key.
	 * @param Connection $con the connection to use
         * @return User
	 */
	public static function retrieveByPK($pk, $con = null)
	{		
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$criteria = new Criteria(self::DATABASE_NAME);
		$criteria->add(self::USER_ID, $pk);
						
		$v = UserPeer::doSelect($criteria, $con);
        return count($v) > 0 ? $v[0] : null;
	}

	/**
	 * Retrieve multiple objects by pkey.
	 *
	 * @param array $pks List of primary keys
	 * @param Connection $con the connection to use
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function retrieveByPKs($pks, $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(self::DATABASE_NAME);
		}
		
		$objs = null;
		if (empty($pks)) {
			$objs = array();
		} else {
			$criteria = new Criteria();
			$criteria->add(self::USER_ID, $pks, Criteria::IN);
  
			$objs = UserPeer::doSelect($criteria, $con);
		}
		return $objs;
	}

 

	/**
	 * Selects a collection of User objects pre-filled with their
	 * CountryCode objects.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinCountryCode(Criteria $c, $con = null)
	{

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol = (self::$numColumns - self::$numLazyLoadColumns) + 1;
		CountryCodePeer::addSelectColumns($c);

			$c->addJoin(UserPeer::CCODE, CountryCodePeer::CCODE);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {
			$omClass = UserPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = CountryCodePeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getCountryCode();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
			$results[] = $obj1;
		}
		return $results;
	}
	/**
	 * Selects a collection of User objects pre-filled with their
	 * Language objects.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinLanguage(Criteria $c, $con = null)
	{

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol = (self::$numColumns - self::$numLazyLoadColumns) + 1;
		LanguagePeer::addSelectColumns($c);

			$c->addJoin(UserPeer::LANGUAGE_ID, LanguagePeer::LANGUAGE_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {
			$omClass = UserPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = LanguagePeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getLanguage();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
			$results[] = $obj1;
		}
		return $results;
	}
	/**
	 * Selects a collection of User objects pre-filled with their
	 * Theme objects.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinTheme(Criteria $c, $con = null)
	{

		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol = (self::$numColumns - self::$numLazyLoadColumns) + 1;
		ThemePeer::addSelectColumns($c);

			$c->addJoin(UserPeer::THEME_ID, ThemePeer::THEME_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();

		while($rs->next()) {
			$omClass = UserPeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);

			$omClass = ThemePeer::getOMClass();
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol);

			$newObject = true;
			foreach($results as $temp_obj1) {
				$temp_obj2 = $temp_obj1->getTheme();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
			$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of User objects pre-filled with
	 * all related objects.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAll(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
 
		CountryCodePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + CountryCodePeer::$numColumns;
		 
		LanguagePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + LanguagePeer::$numColumns;
		 
		ThemePeer::addSelectColumns($c);
		$startcol5 = $startcol4 + ThemePeer::$numColumns;
				$c->addJoin(UserPeer::CCODE, CountryCodePeer::CCODE);
	 		$c->addJoin(UserPeer::LANGUAGE_ID, LanguagePeer::LANGUAGE_ID);
	 		$c->addJoin(UserPeer::THEME_ID, ThemePeer::THEME_ID);
	 
		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
 
			$omClass = UserPeer::getOMClass();
			
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
	 
			
			// Add objects for joined CountryCode rows
 
			$omClass = CountryCodePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2 = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getCountryCode();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
	 
			
			// Add objects for joined Language rows
 
			$omClass = LanguagePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3 = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getLanguage();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initUsers();
				$obj3->addUser($obj1);
			}
	 
			
			// Add objects for joined Theme rows
 
			$omClass = ThemePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj4 = new $cls();
			$obj4->hydrate($rs, $startcol4);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj4 = $temp_obj1->getTheme();
				if ($temp_obj4->getPrimaryKey() === $obj4->getPrimaryKey()) {
					$newObject = false;
					$temp_obj4->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj4->initUsers();
				$obj4->addUser($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of User objects pre-filled with
	 * all related objects except CountryCode.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptCountryCode(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
	 
		LanguagePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + LanguagePeer::$numColumns;
		 
		ThemePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + ThemePeer::$numColumns;
				$c->addJoin(UserPeer::LANGUAGE_ID, LanguagePeer::LANGUAGE_ID);
	 		$c->addJoin(UserPeer::THEME_ID, ThemePeer::THEME_ID);
	 

		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
				$omClass = UserPeer::getOMClass();
				
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
				$omClass = LanguagePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getLanguage();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
				$omClass = ThemePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getTheme();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initUsers();
				$obj3->addUser($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of User objects pre-filled with
	 * all related objects except Language.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptLanguage(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
	 
		CountryCodePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + CountryCodePeer::$numColumns;
		 
		ThemePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + ThemePeer::$numColumns;
				$c->addJoin(UserPeer::CCODE, CountryCodePeer::CCODE);
	 		$c->addJoin(UserPeer::THEME_ID, ThemePeer::THEME_ID);
	 

		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
				$omClass = UserPeer::getOMClass();
				
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
				$omClass = CountryCodePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getCountryCode();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
				$omClass = ThemePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getTheme();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initUsers();
				$obj3->addUser($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}

	/**
	 * Selects a collection of User objects pre-filled with
	 * all related objects except Theme.
	 *
	 * @return array Array of User objects.
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	public static function doSelectJoinAllExceptTheme(Criteria $c, $con = null)
	{
		// Set the correct dbName if it has not been overridden
		// $c->getDbName() will return the same object if not set to another value
		// so == check is okay and faster
		if ($c->getDbName() == Propel::getDefaultDB()) {
			$c->setDbName(self::DATABASE_NAME);
		}

		UserPeer::addSelectColumns($c);
		$startcol2 = (self::$numColumns - self::$numLazyLoadColumns) + 1;
	 
		CountryCodePeer::addSelectColumns($c);
		$startcol3 = $startcol2 + CountryCodePeer::$numColumns;
		 
		LanguagePeer::addSelectColumns($c);
		$startcol4 = $startcol3 + LanguagePeer::$numColumns;
				$c->addJoin(UserPeer::CCODE, CountryCodePeer::CCODE);
	 		$c->addJoin(UserPeer::LANGUAGE_ID, LanguagePeer::LANGUAGE_ID);
	 

		$rs = BasePeer::doSelect($c, $con);
		$results = array();
		
		while($rs->next()) {
				$omClass = UserPeer::getOMClass();
				
			$cls = Propel::import($omClass);
			$obj1 = new $cls();
			$obj1->hydrate($rs);
			
				$omClass = CountryCodePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj2  = new $cls();
			$obj2->hydrate($rs, $startcol2);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj2 = $temp_obj1->getCountryCode();
				if ($temp_obj2->getPrimaryKey() === $obj2->getPrimaryKey()) {
					$newObject = false;
					$temp_obj2->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj2->initUsers();
				$obj2->addUser($obj1);
			}
				$omClass = LanguagePeer::getOMClass();
	
			$cls = Propel::import($omClass);
			$obj3  = new $cls();
			$obj3->hydrate($rs, $startcol3);
			
			$newObject = true;
			for ($j=0, $resCount=count($results); $j < $resCount; $j++) {
				$temp_obj1 = $results[$j];
				$temp_obj3 = $temp_obj1->getLanguage();
				if ($temp_obj3->getPrimaryKey() === $obj3->getPrimaryKey()) {
					$newObject = false;
					$temp_obj3->addUser($obj1);
					break;
				}
			}
			
			if ($newObject) {
				$obj3->initUsers();
				$obj3->addUser($obj1);
			}
				$results[] = $obj1;
		}
		return $results;
	}
	/**
	 * Returns the TableMap related to this peer.  This method is not
	 * needed for general use but a specific application could have a need.
	 * @return TableMap
	 * @throws PropelException Any exceptions caught during processing will be
	 *		 rethrown wrapped into a PropelException.
	 */
	protected static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}
	
}

// static code to register the map builder for this Peer with the main Propel class
if (Propel::isInit()) {
	// the MapBuilder classes register themselves with Propel during initialization
	// so we need to load them here.
	try {		
		BaseUserPeer::getMapBuilder();
	} catch (Exception $e) {
		Propel::log("Could not initialize Peer: " . $e->getMessage(), Propel::LOG_ERR);
	}
} else {
	// even if Propel is not yet initialized, the map builder class can be registered
	// now and then it will be loaded when Propel initializes.
	require_once 'core/map/UserMapBuilder.php';
	Propel::registerMapBuilder(UserMapBuilder::CLASS_NAME);
}
