<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/frs/lib/html/FrsTemplate.php');
require_once('lib/plugin/PluginResult.php');

class FrsAdminTemplate extends FrsTemplate {

	/**
	 * Header - this subclasses header and just passes params and data that is specific
	 * to this template
	 * @param array array of parameters
	 */
	function header($params) {
				
		if(!isset($params['project']) || !is_object($params['project'])) {
			Throw new exception('Missing project object in frs template');		
		}
		if (!isset($params['title'])) {
			Throw new exception('Missing title in frs template'); 
		}
	
		$params['title']=' Admin > '.$params['title'];

		//hack to suppress one breadcrumb when in admin
		$params['frsadmin']='frsadmin';

		//release breadcrumb
		if (isset($params['frsrelease'])) {
			$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','frs','admin',array('action'=>'FrsReleaseEdit','frs_release_id'=>$params['frsrelease']->getFrsReleaseId())).'">'.$params['frsrelease']->getReleaseName().'</a>');
		}
		//package breadcrumb
		if (isset($params['frspackage'])) {
			$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','frs','admin',array('action'=>'FrsPackageEdit','frs_package_id'=>$params['frspackage']->getFrsPackageId())).'">'.$params['frspackage']->getPackageName().'</a>');
		}

		//package-level perm check - allow them if they are overall admin or just package admin
		if (isset($params['frspackage'])) {
			if(!$params['frspackage']->userIsAdmin()) {
				Throw new PermissionDeniedException();
			}
		} elseif(!$params['project']->getPermission()->check(FrsPlugin::SECTION,0,FrsPlugin::WRITE)) {
			Throw new PermissionDeniedException();
		}
		$this->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','frs','admin').'">'.Language::getSessText('Tabs.Admin').'</a>');					
		return parent::header($params);
	}

	/**
	 *      getPluginNavElements - this overrides parent class and adds its own
	 *      plugin listener
	 *      @return PluginResultSet
	 */
	function getPluginNavElements($params) {
		$prs = parent::getPluginNavElements($params);
		$tprs = ActionManager::Notify('GET_FRS_ADMIN_NAV_ELEMENTS',null);
		foreach ($tprs as $pr) {
			$prs->addResult($pr);
		}
		return $prs;
	}


	/**
	 * getTemplateNavElements - this function can be overridden
	 * by subclasses so you can add navigation entries
	 * @return array - complex array of data.
	 * /
	 
	function getTemplateNavElements($params) {
		$pine = $this->getPluginNavElements($params);
		foreach ($pine as $result) {
			$ret[]=$result->getResult();
		}
		if (!isset($params['project'])) {
			echo 'missing project param';
		}
		$ret[] = array(
			'title'=>'FRS',
			'elements'=> array(
			array('link'=> GFUrl::getUrl()->projectURL($params['project'], 'admin', 'frs'),
				'description'=>'Admin'),
			)
		);
		return $ret;
	}
	*/

}

?>
