<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing FrsPackage
//
require_once('plugins/frs/lib/FrsPackagePeer.php');
require_once('plugins/frs/lib/FrsPackage.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsAdminTemplate.php');
$theme = new FrsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$FrsPackage = FrsPackagePeer::retrieveByPk($_REQUEST['frs_package_id']);
if (!is_object($FrsPackage) || $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}
if (!$FrsPackage->userCanUpdate()) {
	throw new PermissionDeniedException();
}
$obj = $FrsPackage;

$params = array(
		'project' => $Project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('FrsPackage.EditPageTitle'),
		'frspackage' => $FrsPackage
		);

//$project_id = ( (isset($_POST) && isset($_POST['project_id'])) ? htmlspecialchars($_POST['project_id']) : $obj->getProjectId() );
$package_name = ( (isset($_POST) && isset($_POST['package_name'])) ? htmlspecialchars($_POST['package_name']) : $obj->getPackageName() );
$status_id = ( (isset($_POST) && isset($_POST['status_id'])) ? htmlspecialchars($_POST['status_id']) : $obj->getStatusId() );
$is_public = ( (isset($_POST) && isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : $obj->getIsPublic() );
$require_login = ( (isset($_POST) && isset($_POST['require_login'])) ? htmlspecialchars($_POST['require_login']) : $obj->getRequireLogin() );

include ('forms/FrsPackageEdit-tpl.php');

?>
