<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a News and saves it to the 
// database
//
require_once('plugins/news/lib/News.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$News = NewsPeer::retrieveByPk($_POST['id']);
if (!is_object($News) || !$News->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$errors = array();
$language = Language::getSessLang();

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//

if (count($errors) == 0) {
	$News->setProjectId( Validator::sanitizeInt($_POST['project_id']) );
	$News->setSubmittedBy( Validator::sanitizeInt($_POST['submitted_by']) );
	$News->setIsApproved( Validator::sanitizeBool($_POST['is_approved']) );
	$News->setPostDate( Validator::sanitizeDate($_POST['post_date']) );
	$News->setSummary( Validator::sanitizeString($_POST['summary']) );
	$News->setDetails( Validator::sanitizeString($_POST['details']) );
	
	$News->save();
	GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('NewsBrowse'), array('feedback' => $language->getText('News.EditFeedback')));
} else {
	$feedback = implode('<br />', $errors);
	include('NewsEdit.php');
}

?>