<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Federico Tarantini      federico@gforgegroup.com
 * @date 2006-11-17
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/graphics/GraphicPie.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

// Date range
$begin = Validator::sanitizeDate($_GET['start_date']);
$end = Validator::sanitizeDate($_GET['end_date']);
$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

$all_ids = array();
if ($subprojects == 1) {
	$all_ids = $Project->getAllSubprojectIds();
	$all_ids[] = $project_id;
} else {
	$all_ids[] = $project_id;
}

$sql = 'SELECT COUNT(sc.user_id) AS commits, u.unix_name
	FROM scm_commit sc, "user" u
	WHERE project_id IN ('.implode(',',$all_ids).') 
	AND sc.user_id = u.user_id 
	AND sc.commit_date BETWEEN \''.$begin.'\' AND \''.$end.'\' 
	GROUP BY u.unix_name 
	ORDER BY commits DESC';

$gp = new GraphicPie($Lang->getText('ScmCommitsReport.CommitsByUser'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('unix_name', 'commits');
$gp->showPie();
