<?php
/**
 * Copyright (c) 2005-2009 GForge, LLC
 *
 * @version   $Id: index.php 620 2006-03-23 16:13:34Z tperdue $
 * @author Rodrigo Hammerly rhammerly@gforge.org
 * @date 2009-10-01
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('GFUrl.php');
require_once('plugins/scmperforce/lib/html/PerforceTemplate.php');
require_once('plugins/scm/lib/RepositoryBrowser.php');
require_once('plugins/scmperforce/lib/PerforceRepository.php');

$project = GFUrl::getUrl()->getProject();
$scmplugin = $project->getPluginByName('scmperforce');
if (is_null($scmplugin)) {
	throw new InvalidPluginException('scmperforce');
}

$session = Session::getSession();
$lang = $session->getLanguage();

$template = new PerforceTemplate();

$params = array(
	'selectedbottomtab'	=> 'scmperforce',
	'project' => $project,
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $lang->getText('Scm.CommitDetails')
	);

// this shows the page from the generic SCM plugin
include_once('plugins/scm/wwwlib/ScmCommitBrowse.php');

?>