<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/tracker/lib/om/BaseTrackerExtraFieldData.php';
require_once("plugin/ActionManager.php");
require_once('core/AuditTrail.php');
require_once('plugins/tracker/lib/TrackerItem.php');

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Wed Nov 16 20:42:33 2005]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerExtraFieldData extends BaseTrackerExtraFieldData {
	
	private $old_field_values = null; // associative array of <column_name>=>old_value. used to track the modified values in the persistent object
	private $audited_fields = array(TrackerExtraFieldDataPeer::FIELD_DATA ); // only this fields will be audited
	
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see TrackerExtraFieldData::setDeleted()
	 * @see TrackerExtraFieldData::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->getTrackerItem()->userCanUpdate()) {
			throw new PermissionDeniedException();
		}
		ActionManager::notify("TRACKER_EXTRA_FIELD_DATA_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
	/*	if ($this->getTrackerItem()->isNew()) {
			if (!$this->getTrackerItem()->userCanCreate()) {
				throw new PermissionDeniedException();
			}
		} else {
			if (!$this->getTrackerItem()->userCanUpdate()) {
				throw new PermissionDeniedException();
			}
		}

		if (!$this->getTrackerItem()->isNew()) { // only audit if the objects Tracker Item is not new
			if (is_array($this->old_field_values)) {
				$keys = array_keys($this->old_field_values);
				for ($i=0;$i<count($this->old_field_values);$i++) {// put an entry in the audit log for each changed value
					if (in_array($keys[$i],$this->audited_fields)) { // only audit the fields we want to audit
						$Audit = new AuditTrail();
						//get the data
						$user_id = $this->getTrackerItem()->getUser()->getUserId();
						$section = TrackerItem::SECTION;
						$ref_id = $this->getTrackerItemId();
						$field_name = substr(strtolower(substr($keys[$i],strlen(TrackerExtraFieldDataPeer::TABLE_NAME)+1)),0,20); // since were getting things like Tablename.field_name, we just want to store the field name
						$old_value = $this->old_field_values[$keys[$i]];
						$new_value = $this->getByName($keys[$i]);
						// set the audit object and save it to DB
						$Audit->setOldValue($old_value);
						$Audit->setNewValue($new_value);
						$Audit->setRefId($ref_id);
						$Audit->setSection($section);
						$Audit->setUserId($user_id);
						$Audit->setFieldName($field_name);
						$Audit->save();
					}
				}
			}
		}		
*/
		parent::save($con);
		$this->old_field_values = null; // now theres not any more old fields since they were saved
		ActionManager::notify("TRACKER_EXTRA_FIELD_DATA_SAVE", $this);
	}

	/**
	 * Set the value of `field_data` column.   set old value
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 * /
	public function setFieldData($v)
	{	
		if ($v !== $this->getFieldData()) {
			$this->old_field_values[BaseTrackerExtraFieldDataPeer::FIELD_DATA] = $this->getFieldData();
		}
		parent::setFieldData($v);
	}
	*/

}
?>