<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/TrackerItemQuery.php');

class TrackerItemSavedQuery extends TrackerItemQuery {

	function __construct(Tracker $Tracker, TrackerQuery $TrackerQuery) {
		parent::__construct($Tracker);
		$this->setupItems($TrackerQuery);
	}

	private function setupItems(TrackerQuery $TrackerQuery) {
		$fields = $TrackerQuery->getTrackerQueryFields();
		foreach ($fields as $field) {
			switch ($field->getQueryFieldType()) {
				case self::FIELD_ASSIGNEE: {
					if ($field->getQueryFieldValues() > 0) {
						$this->assignee=explode(',',$field->getQueryFieldValues());
					} else {
						$this->assignee=array();
					}
					break;
				}
				case self::FIELD_PRIORITY: {
					if ($field->getQueryFieldValues() > 0) {
						$this->priority=explode(',',$field->getQueryFieldValues());
					} else {
						$this->priority= array();
					}
					break;
				}
				case self::FIELD_MODDATE: {
					$this->moddaterange=$field->getQueryFieldValues();
					break;
				}
				case self::FIELD_CLOSEDATE: {
					$this->closedaterange=$field->getQueryFieldValues();
					break;
				}
				case self::FIELD_OPENDATE: {
					$this->opendaterange=$field->getQueryFieldValues();
					break;
				}
				case self::FIELD_SORTCOL: {
					$this->sortcol=$field->getQueryFieldValues();
					break;
				}
				case self::FIELD_SORTORD: {
					$this->sortord=$field->getQueryFieldValues();
					break;
				}
				case self::FIELD_EXTRAFIELD: {
					/*if (strpos($field->getQueryFieldValues(),'*DATE*') !== false) {
						$this->extra_fields[$field->getQueryFieldId()]=
							explode('*DATE*',$field->getQueryFieldValues());
					} elseif (strpos($field->getQueryFieldValues(),'*NUMERIC*') !== false) {
						$this->extra_fields[$field->getQueryFieldId()]=
							explode('*NUMERIC*',$field->getQueryFieldValues());
					} else {*/
						$this->extra_fields[$field->getQueryFieldId()]=
							explode(',',$field->getQueryFieldValues());
					//}
					break;
				}
			}
		}
	//	return $this->getTrackerItems();
	}

}

?>
