<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker_commit_trigger' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerCommitTriggerMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerCommitTriggerMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker_commit_trigger");
		$tMap->setPhpName("TrackerCommitTrigger");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_commit_trigger_tracker_commit_trigger_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TRACKER_COMMIT_TRIGGER_ID", "TrackerCommitTriggerId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("TRACKER_ID", "TrackerId", "int", CreoleTypes::INTEGER, "tracker" , "TRACKER_ID", true);
		$tMap->addForeignKey("CHANGE_TRACKER_EXTRA_FIELD_ID", "ChangeTrackerExtraFieldId", "int", CreoleTypes::INTEGER, "tracker_extra_field" , "TRACKER_EXTRA_FIELD_ID", true);
		$tMap->addForeignKey("TO_ELEMENT_ID", "ToElementId", "int", CreoleTypes::INTEGER, "tracker_extra_field_element" , "ELEMENT_ID", true);
				
    }
}
