<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/Tracker.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerPeer.php';

include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';

/**
 * Base class that represents a row from the 'tracker_extra_field' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerExtraField class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerExtraField extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerExtraFieldPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_extra_field_id field.
	 * @var int	  
	 */
	protected $tracker_extra_field_id;	

	/**
	 * The value for the tracker_id field.
	 * @var int	  
	 */
	protected $tracker_id;	

	/**
	 * The value for the field_name field.
	 * @var string	  
	 */
	protected $field_name;	

	/**
	 * The value for the field_type field.
	 * @var int	  
	 */
	protected $field_type;	

	/**
	 * The value for the attribute1 field.
	 * @var int	  
	 */
	protected $attribute1 = 0;	

	/**
	 * The value for the attribute2 field.
	 * @var int	  
	 */
	protected $attribute2 = 0;	

	/**
	 * The value for the is_required field.
	 * @var boolean	  
	 */
	protected $is_required = false;	

	/**
	 * The value for the alias field.
	 * @var string	  
	 */
	protected $alias;	

	/**
	 * The value for the field_order field.
	 * @var int	  
	 */
	protected $field_order = 0;	

	/**
	 * The value for the use_in_quick_browse field.
	 * @var boolean	  
	 */
	protected $use_in_quick_browse = false;	

	/**
	 * The value for the show_on_submit field.
	 * @var boolean	  
	 */
	protected $show_on_submit = false;	

	/**
	 * The value for the use_auto_assign field.
	 * @var boolean	  
	 */
	protected $use_auto_assign = false;	

	/**
	 * The value for the use_workflow field.
	 * @var boolean	  
	 */
	protected $use_workflow = false;	

	/**
	 * The value for the use_commit_rule field.
	 * @var boolean	  
	 */
	protected $use_commit_rule = false;	

	/**
	 * The value for the default_value field.
	 * @var string	  
	 */
	protected $default_value;	
  
	/**
	 * Get the TrackerExtraFieldId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerExtraFieldId()
	{
		return $this->tracker_extra_field_id;
	}


	/**
	 * Set the value of `tracker_extra_field_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerExtraFieldId($v)
	{
		if ($this->tracker_extra_field_id !== $v) {
			$this->tracker_extra_field_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID;
		}
			
		  // update associated TrackerExtraFieldData		  
		  if ($this->collTrackerExtraFieldDatas !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldDatas); $i < $size; $i++) {
				  $this->collTrackerExtraFieldDatas[$i]->setTrackerExtraFieldId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraFieldElement		  
		  if ($this->collTrackerExtraFieldElements !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldElements); $i < $size; $i++) {
				  $this->collTrackerExtraFieldElements[$i]->setTrackerExtraFieldId($v);
			  }
		  }
			  	
		  // update associated TrackerEfeTransitionTrigger		  
		  if ($this->collTrackerEfeTransitionTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerEfeTransitionTriggers); $i < $size; $i++) {
				  $this->collTrackerEfeTransitionTriggers[$i]->setChangeTrackerExtraFieldId($v);
			  }
		  }
			  	
		  // update associated TrackerCommitTrigger		  
		  if ($this->collTrackerCommitTriggers !== null) {
			  for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
				  $this->collTrackerCommitTriggers[$i]->setChangeTrackerExtraFieldId($v);
			  }
		  }
			  	
		  // update associated TrackerExtraFieldElementTransitionField		  
		  if ($this->collTrackerExtraFieldElementTransitionFields !== null) {
			  for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionFields); $i < $size; $i++) {
				  $this->collTrackerExtraFieldElementTransitionFields[$i]->setRequiredTrackerExtraFieldId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the TrackerId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerId()
	{
		return $this->tracker_id;
	}


	/**
	 * Set the value of `tracker_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerId($v)
	{
		if ($this->tracker_id !== $v) {
			$this->tracker_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::TRACKER_ID;
		}
			
		if ($this->aTracker !== null && $this->aTracker->getTrackerId() !== $v) {
			$this->aTracker = null;
		}
			
	}

  
	/**
	 * Get the FieldName column value.
	 *  
	 * @return string	  
	 */
	public function getFieldName()
	{
		return $this->field_name;
	}


	/**
	 * Set the value of `field_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldName($v)
	{
		if ($this->field_name !== $v) {
			$this->field_name = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::FIELD_NAME;
		}
				
	}

  
	/**
	 * Get the FieldType column value.
	 *  
	 * @return int	  
	 */
	public function getFieldType()
	{
		return $this->field_type;
	}


	/**
	 * Set the value of `field_type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFieldType($v)
	{
		if ($this->field_type !== $v) {
			$this->field_type = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::FIELD_TYPE;
		}
				
	}

  
	/**
	 * Get the Attribute1 column value.
	 *  
	 * @return int	  
	 */
	public function getAttribute1()
	{
		return $this->attribute1;
	}


	/**
	 * Set the value of `attribute1` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setAttribute1($v)
	{
		if ($this->attribute1 !== $v || $v === 0) {
			$this->attribute1 = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::ATTRIBUTE1;
		}
				
	}

  
	/**
	 * Get the Attribute2 column value.
	 *  
	 * @return int	  
	 */
	public function getAttribute2()
	{
		return $this->attribute2;
	}


	/**
	 * Set the value of `attribute2` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setAttribute2($v)
	{
		if ($this->attribute2 !== $v || $v === 0) {
			$this->attribute2 = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::ATTRIBUTE2;
		}
				
	}

  
	/**
	 * Get the IsRequired column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsRequired()
	{
		return $this->is_required;
	}


	/**
	 * Set the value of `is_required` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsRequired($v)
	{
		if ($this->is_required !== $v || $v === false) {
			$this->is_required = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::IS_REQUIRED;
		}
				
	}

  
	/**
	 * Get the Alias column value.
	 *  
	 * @return string	  
	 */
	public function getAlias()
	{
		return $this->alias;
	}


	/**
	 * Set the value of `alias` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAlias($v)
	{
		if ($this->alias !== $v) {
			$this->alias = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::ALIAS;
		}
				
	}

  
	/**
	 * Get the FieldOrder column value.
	 *  
	 * @return int	  
	 */
	public function getFieldOrder()
	{
		return $this->field_order;
	}


	/**
	 * Set the value of `field_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFieldOrder($v)
	{
		if ($this->field_order !== $v || $v === 0) {
			$this->field_order = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::FIELD_ORDER;
		}
				
	}

  
	/**
	 * Get the UseInQuickBrowse column value.
	 *  
	 * @return boolean	  
	 */
	public function getUseInQuickBrowse()
	{
		return $this->use_in_quick_browse;
	}


	/**
	 * Set the value of `use_in_quick_browse` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setUseInQuickBrowse($v)
	{
		if ($this->use_in_quick_browse !== $v || $v === false) {
			$this->use_in_quick_browse = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE;
		}
				
	}

  
	/**
	 * Get the ShowOnSubmit column value.
	 *  
	 * @return boolean	  
	 */
	public function getShowOnSubmit()
	{
		return $this->show_on_submit;
	}


	/**
	 * Set the value of `show_on_submit` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setShowOnSubmit($v)
	{
		if ($this->show_on_submit !== $v || $v === false) {
			$this->show_on_submit = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::SHOW_ON_SUBMIT;
		}
				
	}

  
	/**
	 * Get the UseAutoAssign column value.
	 *  
	 * @return boolean	  
	 */
	public function getUseAutoAssign()
	{
		return $this->use_auto_assign;
	}


	/**
	 * Set the value of `use_auto_assign` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setUseAutoAssign($v)
	{
		if ($this->use_auto_assign !== $v || $v === false) {
			$this->use_auto_assign = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::USE_AUTO_ASSIGN;
		}
				
	}

  
	/**
	 * Get the UseWorkflow column value.
	 *  
	 * @return boolean	  
	 */
	public function getUseWorkflow()
	{
		return $this->use_workflow;
	}


	/**
	 * Set the value of `use_workflow` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setUseWorkflow($v)
	{
		if ($this->use_workflow !== $v || $v === false) {
			$this->use_workflow = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::USE_WORKFLOW;
		}
				
	}

  
	/**
	 * Get the UseCommitRule column value.
	 *  
	 * @return boolean	  
	 */
	public function getUseCommitRule()
	{
		return $this->use_commit_rule;
	}


	/**
	 * Set the value of `use_commit_rule` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setUseCommitRule($v)
	{
		if ($this->use_commit_rule !== $v || $v === false) {
			$this->use_commit_rule = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::USE_COMMIT_RULE;
		}
				
	}

  
	/**
	 * Get the DefaultValue column value.
	 *  
	 * @return string	  
	 */
	public function getDefaultValue()
	{
		return $this->default_value;
	}


	/**
	 * Set the value of `default_value` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setDefaultValue($v)
	{
		if ($this->default_value !== $v) {
			$this->default_value = $v;
			$this->modifiedColumns[] = TrackerExtraFieldPeer::DEFAULT_VALUE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_extra_field_id = $rs->getInt($startcol + 0);					
			$this->tracker_id = $rs->getInt($startcol + 1);					
			$this->field_name = $rs->getString($startcol + 2);					
			$this->field_type = $rs->getInt($startcol + 3);					
			$this->attribute1 = $rs->getInt($startcol + 4);					
			$this->attribute2 = $rs->getInt($startcol + 5);					
			$this->is_required = $rs->getBoolean($startcol + 6);					
			$this->alias = $rs->getString($startcol + 7);					
			$this->field_order = $rs->getInt($startcol + 8);					
			$this->use_in_quick_browse = $rs->getBoolean($startcol + 9);					
			$this->show_on_submit = $rs->getBoolean($startcol + 10);					
			$this->use_auto_assign = $rs->getBoolean($startcol + 11);					
			$this->use_workflow = $rs->getBoolean($startcol + 12);					
			$this->use_commit_rule = $rs->getBoolean($startcol + 13);					
			$this->default_value = $rs->getString($startcol + 14);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerExtraField object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerExtraFieldPeer::DATABASE_NAME);
		$criteria->add(TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID, $this->tracker_extra_field_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerExtraFieldPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID)) $criteria->add(TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID, $this->tracker_extra_field_id);
		if ($this->isColumnModified(TrackerExtraFieldPeer::TRACKER_ID)) $criteria->add(TrackerExtraFieldPeer::TRACKER_ID, $this->tracker_id);
		if ($this->isColumnModified(TrackerExtraFieldPeer::FIELD_NAME)) $criteria->add(TrackerExtraFieldPeer::FIELD_NAME, $this->field_name);
		if ($this->isColumnModified(TrackerExtraFieldPeer::FIELD_TYPE)) $criteria->add(TrackerExtraFieldPeer::FIELD_TYPE, $this->field_type);
		if ($this->isColumnModified(TrackerExtraFieldPeer::ATTRIBUTE1)) $criteria->add(TrackerExtraFieldPeer::ATTRIBUTE1, $this->attribute1);
		if ($this->isColumnModified(TrackerExtraFieldPeer::ATTRIBUTE2)) $criteria->add(TrackerExtraFieldPeer::ATTRIBUTE2, $this->attribute2);
		if ($this->isColumnModified(TrackerExtraFieldPeer::IS_REQUIRED)) $criteria->add(TrackerExtraFieldPeer::IS_REQUIRED, $this->is_required);
		if ($this->isColumnModified(TrackerExtraFieldPeer::ALIAS)) $criteria->add(TrackerExtraFieldPeer::ALIAS, $this->alias);
		if ($this->isColumnModified(TrackerExtraFieldPeer::FIELD_ORDER)) $criteria->add(TrackerExtraFieldPeer::FIELD_ORDER, $this->field_order);
		if ($this->isColumnModified(TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE)) $criteria->add(TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE, $this->use_in_quick_browse);
		if ($this->isColumnModified(TrackerExtraFieldPeer::SHOW_ON_SUBMIT)) $criteria->add(TrackerExtraFieldPeer::SHOW_ON_SUBMIT, $this->show_on_submit);
		if ($this->isColumnModified(TrackerExtraFieldPeer::USE_AUTO_ASSIGN)) $criteria->add(TrackerExtraFieldPeer::USE_AUTO_ASSIGN, $this->use_auto_assign);
		if ($this->isColumnModified(TrackerExtraFieldPeer::USE_WORKFLOW)) $criteria->add(TrackerExtraFieldPeer::USE_WORKFLOW, $this->use_workflow);
		if ($this->isColumnModified(TrackerExtraFieldPeer::USE_COMMIT_RULE)) $criteria->add(TrackerExtraFieldPeer::USE_COMMIT_RULE, $this->use_commit_rule);
		if ($this->isColumnModified(TrackerExtraFieldPeer::DEFAULT_VALUE)) $criteria->add(TrackerExtraFieldPeer::DEFAULT_VALUE, $this->default_value);
		return $criteria;			
	}
	
	

	/**
	 * @var Tracker	  
	 */
	protected $aTracker;

	/**
	 * Declares an association between this object and a Tracker object
	 *
	 * @param Tracker $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTracker($v)
	{
			
		if ($v === null) {
			$this->setTrackerId(NULL);
		} else {
			$this->setTrackerId($v->getTrackerId());
		}
   
		$this->aTracker = $v;
	}


	/**
	 * Get the associated Tracker object
	 *
	 * @param Connection Optional Connection object.
	 * @return Tracker The associated Tracker object.
	 * @throws PropelException
	 */
	public function getTracker($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerPeer.php';

		if ($this->aTracker === null && ($this->tracker_id !== null)) {
	
			$this->aTracker = TrackerPeer::retrieveByPK($this->tracker_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerPeer::retrieveByPK($this->tracker_id, $con);
			   $obj->addTrackerExtraFields($this);
			 */
		}
		return $this->aTracker;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerKey($key)
	{

		$this->setTrackerId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldDatas	  
	 * @var array
	 */
	protected $collTrackerExtraFieldDatas; 

	/**
	 * Temporary storage of collTrackerExtraFieldDatas to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldDatas()
	{
		if ($this->collTrackerExtraFieldDatas === null) {
			$this->collTrackerExtraFieldDatas = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldData object to this object
	 * through the TrackerExtraFieldData foreign key attribute
	 *
	 * @param TrackerExtraFieldData $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldData(TrackerExtraFieldData $l)
	{
		$this->collTrackerExtraFieldDatas[] = $l;
		$l->setTrackerExtraField($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldDatas.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldDatasCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldDatas from storage.
	 * If this TrackerExtraField is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldDatas($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldDatas === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldDatas = array();
			} else {
	
				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId() );

				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());

				if (!isset($this->lastTrackerExtraFieldDatasCriteria) || !$this->lastTrackerExtraFieldDatasCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldDatasCriteria = $criteria;

		return $this->collTrackerExtraFieldDatas;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldDatas from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerExtraFieldDatasJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldDatas === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldDatas = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerExtraFieldDatasCriteria) || !$this->lastTrackerExtraFieldDatasCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldDatasCriteria = $criteria;

		return $this->collTrackerExtraFieldDatas;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldDatas from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerExtraFieldDatasJoinTrackerItem($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldDatas === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldDatas = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerExtraFieldDatasCriteria) || !$this->lastTrackerExtraFieldDatasCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldDatas = TrackerExtraFieldDataPeer::doSelectJoinTrackerItem($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldDatasCriteria = $criteria;

		return $this->collTrackerExtraFieldDatas;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldElements	  
	 * @var array
	 */
	protected $collTrackerExtraFieldElements; 

	/**
	 * Temporary storage of collTrackerExtraFieldElements to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldElements()
	{
		if ($this->collTrackerExtraFieldElements === null) {
			$this->collTrackerExtraFieldElements = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldElement object to this object
	 * through the TrackerExtraFieldElement foreign key attribute
	 *
	 * @param TrackerExtraFieldElement $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldElement(TrackerExtraFieldElement $l)
	{
		$this->collTrackerExtraFieldElements[] = $l;
		$l->setTrackerExtraField($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldElements.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldElementsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldElements from storage.
	 * If this TrackerExtraField is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldElements($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldElements === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElements = array();
			} else {
	
				$criteria->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId() );

				$this->collTrackerExtraFieldElements = TrackerExtraFieldElementPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());

				if (!isset($this->lastTrackerExtraFieldElementsCriteria) || !$this->lastTrackerExtraFieldElementsCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldElements = TrackerExtraFieldElementPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldElementsCriteria = $criteria;

		return $this->collTrackerExtraFieldElements;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldElements from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerExtraFieldElementsJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElements === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElements = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerExtraFieldElements = TrackerExtraFieldElementPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerExtraFieldElementsCriteria) || !$this->lastTrackerExtraFieldElementsCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElements = TrackerExtraFieldElementPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementsCriteria = $criteria;

		return $this->collTrackerExtraFieldElements;
	}

	/**
	 * Collection to store aggregation of collTrackerEfeTransitionTriggers	  
	 * @var array
	 */
	protected $collTrackerEfeTransitionTriggers; 

	/**
	 * Temporary storage of collTrackerEfeTransitionTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerEfeTransitionTriggers()
	{
		if ($this->collTrackerEfeTransitionTriggers === null) {
			$this->collTrackerEfeTransitionTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerEfeTransitionTrigger object to this object
	 * through the TrackerEfeTransitionTrigger foreign key attribute
	 *
	 * @param TrackerEfeTransitionTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerEfeTransitionTrigger(TrackerEfeTransitionTrigger $l)
	{
		$this->collTrackerEfeTransitionTriggers[] = $l;
		$l->setTrackerExtraField($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerEfeTransitionTriggers.
	 * @var Criteria
	 */
	private $lastTrackerEfeTransitionTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 * If this TrackerExtraField is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerEfeTransitionTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	
				$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId() );

				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());

				if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
					$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerEfeTransitionTriggersJoinTrackerExtraFieldElementTransition($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerEfeTransitionTriggersJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerEfeTransitionTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerEfeTransitionTriggersJoinTrackerExtraFieldElement($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerEfeTransitionTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerEfeTransitionTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerEfeTransitionTriggers = array();
			} else {
	   
				$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerEfeTransitionTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerEfeTransitionTriggersCriteria) || !$this->lastTrackerEfeTransitionTriggersCriteria->equals($criteria)) {
				$this->collTrackerEfeTransitionTriggers = TrackerEfeTransitionTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		}
		$this->lastTrackerEfeTransitionTriggersCriteria = $criteria;

		return $this->collTrackerEfeTransitionTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerCommitTriggers	  
	 * @var array
	 */
	protected $collTrackerCommitTriggers; 

	/**
	 * Temporary storage of collTrackerCommitTriggers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerCommitTriggers()
	{
		if ($this->collTrackerCommitTriggers === null) {
			$this->collTrackerCommitTriggers = array();
		}
	}

	/**
	 * Method called to associate a TrackerCommitTrigger object to this object
	 * through the TrackerCommitTrigger foreign key attribute
	 *
	 * @param TrackerCommitTrigger $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerCommitTrigger(TrackerCommitTrigger $l)
	{
		$this->collTrackerCommitTriggers[] = $l;
		$l->setTrackerExtraField($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerCommitTriggers.
	 * @var Criteria
	 */
	private $lastTrackerCommitTriggersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 * If this TrackerExtraField is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerCommitTriggers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	
				$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId() );

				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());

				if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
					$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerCommitTriggersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerCommitTriggersJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerCommitTriggers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerCommitTriggersJoinTrackerExtraFieldElement($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerCommitTriggerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerCommitTriggers === null) {
			if ($this->isNew()) {
			   $this->collTrackerCommitTriggers = array();
			} else {
	   
				$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerCommitTriggerPeer::CHANGE_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerCommitTriggersCriteria) || !$this->lastTrackerCommitTriggersCriteria->equals($criteria)) {
				$this->collTrackerCommitTriggers = TrackerCommitTriggerPeer::doSelectJoinTrackerExtraFieldElement($criteria, $con);
			}
		}
		$this->lastTrackerCommitTriggersCriteria = $criteria;

		return $this->collTrackerCommitTriggers;
	}

	/**
	 * Collection to store aggregation of collTrackerExtraFieldElementTransitionFields	  
	 * @var array
	 */
	protected $collTrackerExtraFieldElementTransitionFields; 

	/**
	 * Temporary storage of collTrackerExtraFieldElementTransitionFields to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initTrackerExtraFieldElementTransitionFields()
	{
		if ($this->collTrackerExtraFieldElementTransitionFields === null) {
			$this->collTrackerExtraFieldElementTransitionFields = array();
		}
	}

	/**
	 * Method called to associate a TrackerExtraFieldElementTransitionField object to this object
	 * through the TrackerExtraFieldElementTransitionField foreign key attribute
	 *
	 * @param TrackerExtraFieldElementTransitionField $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addTrackerExtraFieldElementTransitionField(TrackerExtraFieldElementTransitionField $l)
	{
		$this->collTrackerExtraFieldElementTransitionFields[] = $l;
		$l->setTrackerExtraField($this);
	}

	/**
	 * The criteria used to select the current contents of collTrackerExtraFieldElementTransitionFields.
	 * @var Criteria
	 */
	private $lastTrackerExtraFieldElementTransitionFieldsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionFields from storage.
	 * If this TrackerExtraField is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getTrackerExtraFieldElementTransitionFields($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collTrackerExtraFieldElementTransitionFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionFields = array();
			} else {
	
				$criteria->add(TrackerExtraFieldElementTransitionFieldPeer::REQUIRED_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId() );

				$this->collTrackerExtraFieldElementTransitionFields = TrackerExtraFieldElementTransitionFieldPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(TrackerExtraFieldElementTransitionFieldPeer::REQUIRED_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());

				if (!isset($this->lastTrackerExtraFieldElementTransitionFieldsCriteria) || !$this->lastTrackerExtraFieldElementTransitionFieldsCriteria->equals($criteria)) {
					$this->collTrackerExtraFieldElementTransitionFields = TrackerExtraFieldElementTransitionFieldPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastTrackerExtraFieldElementTransitionFieldsCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionFields;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionFields from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraFieldElementTransition($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElementTransitionFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionFields = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementTransitionFieldPeer::REQUIRED_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerExtraFieldElementTransitionFields = TrackerExtraFieldElementTransitionFieldPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementTransitionFieldPeer::REQUIRED_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerExtraFieldElementTransitionFieldsCriteria) || !$this->lastTrackerExtraFieldElementTransitionFieldsCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElementTransitionFields = TrackerExtraFieldElementTransitionFieldPeer::doSelectJoinTrackerExtraFieldElementTransition($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementTransitionFieldsCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionFields;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this TrackerExtraField is new, it will return
	 * an empty collection; or if this TrackerExtraField has previously
	 * been saved, it will retrieve related TrackerExtraFieldElementTransitionFields from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in TrackerExtraField.
	 */
	public function getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraField($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldElementTransitionFieldPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collTrackerExtraFieldElementTransitionFields === null) {
			if ($this->isNew()) {
			   $this->collTrackerExtraFieldElementTransitionFields = array();
			} else {
	   
				$criteria->add(TrackerExtraFieldElementTransitionFieldPeer::REQUIRED_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
				$this->collTrackerExtraFieldElementTransitionFields = TrackerExtraFieldElementTransitionFieldPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(TrackerExtraFieldElementTransitionFieldPeer::REQUIRED_TRACKER_EXTRA_FIELD_ID, $this->getTrackerExtraFieldId());
			if (!isset($this->lastTrackerExtraFieldElementTransitionFieldsCriteria) || !$this->lastTrackerExtraFieldElementTransitionFieldsCriteria->equals($criteria)) {
				$this->collTrackerExtraFieldElementTransitionFields = TrackerExtraFieldElementTransitionFieldPeer::doSelectJoinTrackerExtraField($criteria, $con);
			}
		}
		$this->lastTrackerExtraFieldElementTransitionFieldsCriteria = $criteria;

		return $this->collTrackerExtraFieldElementTransitionFields;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_extra_field_id", "tracker_id", "field_name", "field_type", "attribute1", "attribute2", "is_required", "alias", "field_order", "use_in_quick_browse", "show_on_submit", "use_auto_assign", "use_workflow", "use_commit_rule", "default_value", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID:
				return $this->getTrackerExtraFieldId();
				break;
		  
			case TrackerExtraFieldPeer::TRACKER_ID:
				return $this->getTrackerId();
				break;
		  
			case TrackerExtraFieldPeer::FIELD_NAME:
				return $this->getFieldName();
				break;
		  
			case TrackerExtraFieldPeer::FIELD_TYPE:
				return $this->getFieldType();
				break;
		  
			case TrackerExtraFieldPeer::ATTRIBUTE1:
				return $this->getAttribute1();
				break;
		  
			case TrackerExtraFieldPeer::ATTRIBUTE2:
				return $this->getAttribute2();
				break;
		  
			case TrackerExtraFieldPeer::IS_REQUIRED:
				return $this->getIsRequired();
				break;
		  
			case TrackerExtraFieldPeer::ALIAS:
				return $this->getAlias();
				break;
		  
			case TrackerExtraFieldPeer::FIELD_ORDER:
				return $this->getFieldOrder();
				break;
		  
			case TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE:
				return $this->getUseInQuickBrowse();
				break;
		  
			case TrackerExtraFieldPeer::SHOW_ON_SUBMIT:
				return $this->getShowOnSubmit();
				break;
		  
			case TrackerExtraFieldPeer::USE_AUTO_ASSIGN:
				return $this->getUseAutoAssign();
				break;
		  
			case TrackerExtraFieldPeer::USE_WORKFLOW:
				return $this->getUseWorkflow();
				break;
		  
			case TrackerExtraFieldPeer::USE_COMMIT_RULE:
				return $this->getUseCommitRule();
				break;
		  
			case TrackerExtraFieldPeer::DEFAULT_VALUE:
				return $this->getDefaultValue();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerExtraFieldId();
				break;
  
			case 1:
				return $this->getTrackerId();
				break;
  
			case 2:
				return $this->getFieldName();
				break;
  
			case 3:
				return $this->getFieldType();
				break;
  
			case 4:
				return $this->getAttribute1();
				break;
  
			case 5:
				return $this->getAttribute2();
				break;
  
			case 6:
				return $this->getIsRequired();
				break;
  
			case 7:
				return $this->getAlias();
				break;
  
			case 8:
				return $this->getFieldOrder();
				break;
  
			case 9:
				return $this->getUseInQuickBrowse();
				break;
  
			case 10:
				return $this->getShowOnSubmit();
				break;
  
			case 11:
				return $this->getUseAutoAssign();
				break;
  
			case 12:
				return $this->getUseWorkflow();
				break;
  
			case 13:
				return $this->getUseCommitRule();
				break;
  
			case 14:
				return $this->getDefaultValue();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID, $arr)) $this->setTrackerExtraFieldId($arr[TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID]);
  
		if (array_key_exists(TrackerExtraFieldPeer::TRACKER_ID, $arr)) $this->setTrackerId($arr[TrackerExtraFieldPeer::TRACKER_ID]);
  
		if (array_key_exists(TrackerExtraFieldPeer::FIELD_NAME, $arr)) $this->setFieldName($arr[TrackerExtraFieldPeer::FIELD_NAME]);
  
		if (array_key_exists(TrackerExtraFieldPeer::FIELD_TYPE, $arr)) $this->setFieldType($arr[TrackerExtraFieldPeer::FIELD_TYPE]);
  
		if (array_key_exists(TrackerExtraFieldPeer::ATTRIBUTE1, $arr)) $this->setAttribute1($arr[TrackerExtraFieldPeer::ATTRIBUTE1]);
  
		if (array_key_exists(TrackerExtraFieldPeer::ATTRIBUTE2, $arr)) $this->setAttribute2($arr[TrackerExtraFieldPeer::ATTRIBUTE2]);
  
		if (array_key_exists(TrackerExtraFieldPeer::IS_REQUIRED, $arr)) $this->setIsRequired($arr[TrackerExtraFieldPeer::IS_REQUIRED]);
  
		if (array_key_exists(TrackerExtraFieldPeer::ALIAS, $arr)) $this->setAlias($arr[TrackerExtraFieldPeer::ALIAS]);
  
		if (array_key_exists(TrackerExtraFieldPeer::FIELD_ORDER, $arr)) $this->setFieldOrder($arr[TrackerExtraFieldPeer::FIELD_ORDER]);
  
		if (array_key_exists(TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE, $arr)) $this->setUseInQuickBrowse($arr[TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE]);
  
		if (array_key_exists(TrackerExtraFieldPeer::SHOW_ON_SUBMIT, $arr)) $this->setShowOnSubmit($arr[TrackerExtraFieldPeer::SHOW_ON_SUBMIT]);
  
		if (array_key_exists(TrackerExtraFieldPeer::USE_AUTO_ASSIGN, $arr)) $this->setUseAutoAssign($arr[TrackerExtraFieldPeer::USE_AUTO_ASSIGN]);
  
		if (array_key_exists(TrackerExtraFieldPeer::USE_WORKFLOW, $arr)) $this->setUseWorkflow($arr[TrackerExtraFieldPeer::USE_WORKFLOW]);
  
		if (array_key_exists(TrackerExtraFieldPeer::USE_COMMIT_RULE, $arr)) $this->setUseCommitRule($arr[TrackerExtraFieldPeer::USE_COMMIT_RULE]);
  
		if (array_key_exists(TrackerExtraFieldPeer::DEFAULT_VALUE, $arr)) $this->setDefaultValue($arr[TrackerExtraFieldPeer::DEFAULT_VALUE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerExtraFieldPeer::TRACKER_EXTRA_FIELD_ID:
				$this->setTrackerExtraFieldId($value);
				break;
	  
			case TrackerExtraFieldPeer::TRACKER_ID:
				$this->setTrackerId($value);
				break;
	  
			case TrackerExtraFieldPeer::FIELD_NAME:
				$this->setFieldName($value);
				break;
	  
			case TrackerExtraFieldPeer::FIELD_TYPE:
				$this->setFieldType($value);
				break;
	  
			case TrackerExtraFieldPeer::ATTRIBUTE1:
				$this->setAttribute1($value);
				break;
	  
			case TrackerExtraFieldPeer::ATTRIBUTE2:
				$this->setAttribute2($value);
				break;
	  
			case TrackerExtraFieldPeer::IS_REQUIRED:
				$this->setIsRequired($value);
				break;
	  
			case TrackerExtraFieldPeer::ALIAS:
				$this->setAlias($value);
				break;
	  
			case TrackerExtraFieldPeer::FIELD_ORDER:
				$this->setFieldOrder($value);
				break;
	  
			case TrackerExtraFieldPeer::USE_IN_QUICK_BROWSE:
				$this->setUseInQuickBrowse($value);
				break;
	  
			case TrackerExtraFieldPeer::SHOW_ON_SUBMIT:
				$this->setShowOnSubmit($value);
				break;
	  
			case TrackerExtraFieldPeer::USE_AUTO_ASSIGN:
				$this->setUseAutoAssign($value);
				break;
	  
			case TrackerExtraFieldPeer::USE_WORKFLOW:
				$this->setUseWorkflow($value);
				break;
	  
			case TrackerExtraFieldPeer::USE_COMMIT_RULE:
				$this->setUseCommitRule($value);
				break;
	  
			case TrackerExtraFieldPeer::DEFAULT_VALUE:
				$this->setDefaultValue($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerExtraFieldId($value);
				break;
  
			case 1:
				$this->setTrackerId($value);
				break;
  
			case 2:
				$this->setFieldName($value);
				break;
  
			case 3:
				$this->setFieldType($value);
				break;
  
			case 4:
				$this->setAttribute1($value);
				break;
  
			case 5:
				$this->setAttribute2($value);
				break;
  
			case 6:
				$this->setIsRequired($value);
				break;
  
			case 7:
				$this->setAlias($value);
				break;
  
			case 8:
				$this->setFieldOrder($value);
				break;
  
			case 9:
				$this->setUseInQuickBrowse($value);
				break;
  
			case 10:
				$this->setShowOnSubmit($value);
				break;
  
			case 11:
				$this->setUseAutoAssign($value);
				break;
  
			case 12:
				$this->setUseWorkflow($value);
				break;
  
			case 13:
				$this->setUseCommitRule($value);
				break;
  
			case 14:
				$this->setDefaultValue($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerExtraFieldPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerExtraFieldPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerExtraFieldPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTracker !== null) {
				if ($this->aTracker->isModified()) $this->aTracker->save($con);
				$this->setTracker($this->aTracker);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerExtraFieldPeer::doInsert($this, $con);
					$this->setTrackerExtraFieldId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerExtraFieldPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collTrackerExtraFieldDatas !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldDatas); $i < $size; $i++) {
					$this->collTrackerExtraFieldDatas[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFieldElements !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElements); $i < $size; $i++) {
					$this->collTrackerExtraFieldElements[$i]->save($con);
				}
			  }
			if ($this->collTrackerEfeTransitionTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionTriggers); $i < $size; $i++) {
					$this->collTrackerEfeTransitionTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerCommitTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
					$this->collTrackerCommitTriggers[$i]->save($con);
				}
			  }
			if ($this->collTrackerExtraFieldElementTransitionFields !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionFields); $i < $size; $i++) {
					$this->collTrackerExtraFieldElementTransitionFields[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerExtraFieldPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTracker !== null) {
				if (($retval = $this->aTracker->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerExtraFieldPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collTrackerExtraFieldDatas !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldDatas); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldDatas[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFieldElements !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElements); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldElements[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerEfeTransitionTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerEfeTransitionTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerEfeTransitionTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerCommitTriggers !== null) {
				for ($i=0,$size=count($this->collTrackerCommitTriggers); $i < $size; $i++) {
					if (($retval = $this->collTrackerCommitTriggers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collTrackerExtraFieldElementTransitionFields !== null) {
				for ($i=0,$size=count($this->collTrackerExtraFieldElementTransitionFields); $i < $size; $i++) {
					if (($retval = $this->collTrackerExtraFieldElementTransitionFields[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_extra_field_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerExtraFieldId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerExtraFieldId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerExtraField Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerExtraField();
		$copyObj->setTrackerId($this->tracker_id);
		$copyObj->setFieldName($this->field_name);
		$copyObj->setFieldType($this->field_type);
		$copyObj->setAttribute1($this->attribute1);
		$copyObj->setAttribute2($this->attribute2);
		$copyObj->setIsRequired($this->is_required);
		$copyObj->setAlias($this->alias);
		$copyObj->setFieldOrder($this->field_order);
		$copyObj->setUseInQuickBrowse($this->use_in_quick_browse);
		$copyObj->setShowOnSubmit($this->show_on_submit);
		$copyObj->setUseAutoAssign($this->use_auto_assign);
		$copyObj->setUseWorkflow($this->use_workflow);
		$copyObj->setUseCommitRule($this->use_commit_rule);
		$copyObj->setDefaultValue($this->default_value);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getTrackerExtraFieldDatas() as $relObj) {
				$copyObj->addTrackerExtraFieldData($relObj->copy());
			}

			foreach($this->getTrackerExtraFieldElements() as $relObj) {
				$copyObj->addTrackerExtraFieldElement($relObj->copy());
			}

			foreach($this->getTrackerEfeTransitionTriggers() as $relObj) {
				$copyObj->addTrackerEfeTransitionTrigger($relObj->copy());
			}

			foreach($this->getTrackerCommitTriggers() as $relObj) {
				$copyObj->addTrackerCommitTrigger($relObj->copy());
			}

			foreach($this->getTrackerExtraFieldElementTransitionFields() as $relObj) {
				$copyObj->addTrackerExtraFieldElementTransitionField($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerExtraFieldId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerExtraFieldPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerExtraFieldPeer();
		}
		return self::$peer;
	}

}
