<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElement.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraFieldElement = TrackerExtraFieldElementPeer::retrieveByPk($_GET['element_id']);
if (!is_object($TrackerExtraFieldElement)) {
	throw new PermissionDeniedException();
}
$Tracker=$TrackerExtraFieldElement->getTrackerExtraField()->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin() 
	|| $Tracker->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldElementBrowse').'&amp;tracker_extra_field_id='.$TrackerExtraFieldElement->getTrackerExtraFieldID().'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraFieldElement.Edit') .'</a>');

$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $Project,
		'tracker'=>$Tracker,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraField.Edit').' > '.$Lang->getText('TrackerExtraFieldElement.Edit').' > '.$Lang->getText('TrackerExtraFieldElement.DeletePageTitle')
		);

include('forms/TrackerExtraFieldElementDelete-tpl.php');

?>
