<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


require_once('html/SiteTemplate.php');
require_once('plugins/wiki/lib/Wiki.php');
require_once('plugins/wiki/lib/html/WikiTemplate.php');

$theme = new WikiTemplate();
$project = GFUrl::getUrl()->getProject();

$post = (isset($_REQUEST['post'])) ? Validator::sanitizeString($_REQUEST['post']) : null;
$editversion = (isset($_REQUEST['editversion'])) ? Validator::sanitizeInt($_REQUEST['editversion']) : null;
$is_new = (isset($_REQUEST['is_new']) && $_REQUEST['is_new']=='true') ? true : false;
$content = (isset($_REQUEST['content'])) ? Validator::sanitizeHtml($_REQUEST['content']) : null;
$archive = (isset($_REQUEST['minor_edit'])) ? false : true;
$parent_page = (isset($_REQUEST['parent_page'])) ? Validator::sanitizeString($_REQUEST['parent_page']) : null;
$pagename = (isset($_REQUEST['pagename'])) ? Validator::sanitizeString($_REQUEST['pagename']) : null;

$section = Project::SECTION; // This should be changed if were in the user wiki wwwlib, for example
$ref_id = $project->getProjectId(); // This should be changed if were in the user wiki wwwlib, for example
$submit = (isset($_REQUEST['submit'])) ? true : false;
$parms=array();

if ($submit) {
	$wiki = new Wiki($section,$ref_id,$theme,$project);
	//instantiage wikipage object
	$wikipage = $wiki->retrievePageByName($post);
	if ($is_new && !is_object($wikipage)) {
		//create new version and page
		$id = $wiki->createNewPage($post, Validator::sanitizeHtml($content));
		if ($parent_page) {
			$c = new Criteria();
			$c->add(WikiPagePeer::SECTION,$section);
			$c->add(WikiPagePeer::REF_ID,$ref_id);
			$c->add(WikiPagePeer::PAGENAME,$parent_page);
			$ParentWiki = WikiPagePeer::doSelectOne($c);
			if (is_object($ParentWiki)) {
				$parent_wiki = new Wiki($section,$ref_id,null,$project);
				$parent_wiki->updateLinks($ParentWiki,$ParentWiki->getLatestContents());
			}
		}
	} else {
		//update the version
		if ($is_new == false) {
			$id = $wiki->updatePage($editversion, Validator::sanitizeHtml($content),$archive);
		} else {
			$feedback = 'ERROR - invalid params';
			$parms['feedback'] = $feedback;
			GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);
		}
	}
	$parms['pageid'] = $id;
	$feedback = 'Edited ok';
} else {
	$feedback = 'ERROR - invalid params';
}

$parms['feedback'] = $feedback;
GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL(''), $parms);

?>
