<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('plugins/wiki/lib/Wiki.php');
require_once('plugins/wiki/lib/html/WikiTemplate.php');

$theme = new WikiTemplate();
$project = GFUrl::getUrl()->getProject();

$section = (isset($_REQUEST['section'])) ? Validator::sanitizeString($_REQUEST['section']) : Project::SECTION;
$ref_id = (isset($_REQUEST['ref_id'])) ? Validator::sanitizeInt($_REQUEST['ref_id']) : $project->getProjectId();
$id = (isset($_REQUEST['id'])) ? Validator::sanitizeInt($_REQUEST['id']) : null;

if ($id && $section && $ref_id) {
	$wiki = new Wiki($section,$ref_id,$theme,$project);
	$PageContent = $wiki->getPageRefs($id);
} else {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? Validator::sanitizeString($_REQUEST['feedback']) : (isset($feedback) ? $feedback : ''),
		'title' => Language::getSessText('Wiki.Refs'),
		'wiki' => $wiki,
		'page' => $wiki->getPage()
		);

$theme->header($params);

echo $PageContent;

$theme->footer();
?>
