<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: User.php 326 2006-01-09 19:49:12Z danper $
 * @author Daniel A. Prez	daniel@gforgegroup.com
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('html/SiteTemplate.php');
require_once('lib/StringUtils.php');
require_once('lib/Validator.php');

$errors = array();

if (!isset($_REQUEST['confirm_hash'])) {
	$errors[] = Language::getSessText('LostLogin.NeedConfirmHash');
}

if(count($errors) == 0) {
	$confirm_hash = $_REQUEST['confirm_hash'];
	// Remove noise from hash produced by buggy mail clients
	$confirm_hash = StringUtils::prepareHash($confirm_hash);
	$c = new Criteria();
	$c->add(UserPeer::CONFIRM_HASH,$confirm_hash);
	$user = UserPeer::doSelectOne($c); // get the user		
	if ((!$user) || (!is_object($user))) {
		$errors[] = Language::getSessText('LostLogin.InvalidHash');
	}
}

if(count($errors) > 0) 	$feedback = implode('<br />', $errors);

$template = new SiteTemplate();
$params = array(
		'selectedtoptab'	=> 'my',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => 'Lost Password'
	);
$template->header($params);


if(count($errors) == 0) include('forms/lostlogin-tpl.php');


$template->footer(array());

?>
