<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a Project and saves it to the 
// database
//
require_once('core/Project.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/scm/lib/SCMRepositoryFactory.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$Project = ProjectPeer::retrieveByPk($_POST['id']);
if (!is_object($Project) || !$Project->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

// Get the SCM configuration for this project (if any)
$repos = ScmRepositoryFactory::getRepository($Project);
if ($repos) {
	$ProjectScm = $repos->getScmConfiguration();
} else {
	$ProjectScm = null;
}

if (array_key_exists('resend',$_POST)) {
	//TODO -> resend email
	$feedback = Language::getSessText('SiteAdmin.ProjectEdit.MailSent').'<br /> ';
} else {
	$errors = array();
	
	if (count($errors) == 0) {
		$Project->setHomepageUrl( Validator::sanitizeString($_POST['homepage_url']) );
		$Project->setStatus( Validator::sanitizeInt($_POST['status']) );
		//$Project->setRegisterLicenseOther( Validator::sanitizeString($_POST['register_license_other']) );
		if (array_key_exists('template',$_POST)) {
			$Project->setIsTemplate(true);
		} else {
			$Project->setIsTemplate(false);
		}
		
		if (!is_null($ProjectScm) && GFConf::get('system.splitScmServers') && isset($_POST['scm_server_id'])) {
			$ProjectScm->setScmServerId( Validator::sanitizeInt($_POST['scm_server_id']) );
			$ProjectScm->save();
		}

		$Project->save();
		$feedback = $Lang->getText('Project.EditFeedback');
	} else {
		$feedback = implode('<br />', $errors);
		include('ProjectEdit.php');
	}	
}

GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ProjectBrowse'), array('feedback' => $feedback));

//
// TODO Validate the values passed by $_POST. Store the errors in $error like
// $errors["field_name"] = error_description
//



?>