<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id:
 * @author Federico Tarantini federico@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('Validator.php');
require_once('lib/SiteNotification.php');
$Lang = $session->getLanguage();
$errors = array();

if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}
$subject = (isset($_POST['sn_subject'])) ? $_POST['sn_subject'] : '';
$message = (isset($_POST['sn_body'])) ? $_POST['sn_body'] : '';
$usersoption = (isset($_POST['notified_users'])) ? $_POST['notified_users'] : '';

$SiteNotification = new SiteNotification();

if(count($errors) == 0){
	if (Validator::sanitizeString($usersoption) == SiteNotification::MONITORED_USERS) {
		$SiteNotification->setUsersOption(SiteNotification::MONITORED_USERS);
	} elseif (Validator::sanitizeString($usersoption) == SiteNotification::ADMIN_USERS) {
		$SiteNotification->setUsersOption(SiteNotification::ADMIN_USERS);
	}

	if (Validator::sanitizeString($subject)) {
		$SiteNotification->setNotificationSubject($subject);
	} else {
		$SiteNotification->setNotificationSubject('');
	}

	if (Validator::sanitizeString($message)) {
		$SiteNotification->setNotificationMessage($message);
	} else {
		$SiteNotification->setNotificationMessage('');
	}

	try {
		$con = Propel::getConnection(NotificationQueuePeer::DATABASE_NAME);
		$con->begin();
		NotificationManager::queue($SiteNotification);
		$con->commit();
		$params = array('feedback' => $Lang->getText('SiteNotification.Sent'));
		GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('SiteNotification', $params));
	} catch (InvalidDataException $ex) {
		$errors = array_merge($errors, $ex->getErrors());
		$feedback = '* '.implode('<br />* ', $errors);
		$con->rollback();
		include('SiteNotifications.php');
	}
} else {
	$feedback = '* '.implode('<br />* ', $errors);
	include('SiteNotifications.php');
}
?>
