<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new Usergroup and saves it to the 
// database
//
require_once('core/User.php');
require_once('core/UserPeer.php');
require_once('core/UsergroupUserPeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();

$group_id = Validator::sanitizeInt($_POST['id']);

if (isset($_POST['sure'])) {
	$Group = UserPeer::retrieveByPk($group_id);
	if (!is_object($Group) || !Session::getSession()->isSiteAdmin()) {
		throw new PermissionDeniedException();
	}
	if ($Group->getIsGroup() != true) {
		throw new PermissionDeniedException();
	}
	
	$group = UserPeer::retrieveByPk($group_id);
	if (!$group) {
		throw new PermissionDeniedException();
	}
	$group->delete();
	$group->save();
	
	GFUrl::redirect($url->currentBaseURL('UsergroupBrowse'), array('feedback' => $Lang->getText('Usergroup.DeleteFeedback')));
} else {
	GFUrl::redirect($url->currentBaseURL('UsergroupBrowse'), array('feedback' => $Lang->getText('UsergroupDeleteForm.DidntConfirm')));
}

?>
