<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Project
//
require_once('html/SiteTemplate.php');
require_once('core/ProjectPeer.php');
require_once('core/Project.php');
require_once('html/Paginator.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$user = $session->getUser();
$Lang = $session->getLanguage();

$theme = new SiteTemplate();

$params = array(
		'selectedtoptab'	=> 'project',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Project.Browse')
		);
$theme->header($params);

$columns = array(
	ProjectPeer::PROJECT_NAME => $Lang->getText('Project.ProjectNameName'),
	ProjectPeer::UNIX_NAME => $Lang->getText('Project.UnixNameName'),
	ProjectPeer::DESCRIPTION => $Lang->getText('Project.DescriptionName')
);

$crit = new Criteria();
$cton1 = $crit->getNewCriterion(ProjectPeer::STATUS, Project::STATUS_ACTIVE);
$cton2 = $crit->getNewCriterion(ProjectPeer::IS_PUBLIC, true);
$cton1->addAnd($cton2);

if ($session->isLoggedIn() || is_object($user)) {
	$arr_project_id = Array();
	$arr_project_id_aux = $user->getAllProjectIds();
	
	foreach ($arr_project_id_aux as $key => $project_id) {
		$arr_project_id[] = $project_id;
	}

	$cton3 = $crit->getNewCriterion(ProjectPeer::PROJECT_ID, $arr_project_id, Criteria::IN);
	$cton1->addOr($cton3);
}
	
$crit->Add($cton1);

$total = ProjectPeer::doCount($crit);

$paginator = new Paginator('project', -1, $total, ProjectPeer::PROJECT_NAME, $columns);
$paginator->addPageClauses($crit);


$theader =$paginator->getSortableTableHeaders($theme);

$arr = ProjectPeer::doSelect($crit);

/*$theader = array();
$theader[] = $Lang->getText('Project.ProjectNameName');
$theader[] = $Lang->getText('Project.UnixNameName');
$theader[] = $Lang->getText('Project.DescriptionName');*/

//echo $paginator->showLimitOptions();
echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Project.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]= '<a href="'.GFUrl::getUrl()->projectUrl($item).'">'.$item->getProjectName().'</a>';
		$trow[]= '<a href="'.GFUrl::getUrl()->projectUrl($item).'">'.$item->getUnixName().'</a>';
		$trow[]= $item->getDescription();
		echo $theme->tableRow($trow, array(), false);
	}
}

//echo $theme->listPaginatorRow($paginator);

$buttons = array();

$buttons[] = '<a href="'. GFUrl::getUrl()->baseURL('ProjectAdd','','register') .'">'. $Lang->getText('Project.AddNew') .'</a>';
$buttons[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('ProjectTroveBrowse') .'">'. $Lang->getText('Project.TroveFilter') .'</a>';

echo $theme->tableBottom($buttons);

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}


// search box for projects
echo '<p><h3>'.$Lang->getText('Project.SearchAllCategories').'</h3></p>';
require_once('forms/ProjectSearch-tpl.php');
echo $Lang->getText('Project.SearchMessage');

$theme->footer($params);

?>
